diff --git a/web/pgadmin/static/js/tree/tree.js b/web/pgadmin/static/js/tree/tree.js
index 68ade0715..1885f6d5d 100644
--- a/web/pgadmin/static/js/tree/tree.js
+++ b/web/pgadmin/static/js/tree/tree.js
@@ -7,245 +7,292 @@
 //
 //////////////////////////////////////////////////////////////////////////
 
-import {isValidData} from 'sources/utils';
+import _ from 'lodash';
 import $ from 'jquery';
-import Alertify from 'pgadmin.alertifyjs';
+import pgAdmin from 'sources/pgadmin';
+
+import { FileType } from 'react-aspen';
+import { TreeNode } from './tree_nodes';
+
+import {isValidData} from 'sources/utils';
+
+function manageTreeEvents(event, eventName, item) {
+  let d = item ? item._metadata.data: [];
+  let node;
+  let obj = pgAdmin.Browser;
+
+  if (d && obj.Nodes[d._type]) {
+    node = obj.Nodes[d._type];
+
+    // If the Browser tree is not initialised yet
+    if (obj.tree === null) return;
+
+    if (eventName == 'dragstart') {
+      obj.tree.handleDraggable(event, item);
+    }
+    if (eventName == 'added' || eventName == 'beforeopen' || eventName == 'loaded') {
+      obj.tree.addNewNode(item.getMetadata('data').id, item.getMetadata('data') ,item), item.parent.path;
+    }
+    if (_.isObject(node.callbacks) &&
+      eventName in node.callbacks &&
+        typeof node.callbacks[eventName] == 'function' &&
+        !node.callbacks[eventName].apply(
+          node, [item, d, obj, [], eventName])) {
+      return true;
+    }
+    /* Raise tree events for the nodes */
+    try {
+      node.trigger(
+        'browser-node.' + eventName, node, item, d
+      );
+      obj.Events.trigger(
+        'pgadmin-browser:tree:' + eventName, item, d, node
+      );
+    } catch (e) {
+      console.warn(e.stack || e);
+      return false;
+    }
+  }
+  return true;
+}
+
+
+export class Tree {
+  constructor(tree, manageTree, pgBrowser) {
+    this.tree = tree;
+    this.tree.onTreeEvents(manageTreeEvents);
+
+    this.rootNode = manageTree.tempTree;
+    this.Nodes = pgBrowser ? pgBrowser.Nodes : pgAdmin.Browser.Nodes;
+
+    this.draggableTypes = {};
+  }
+
+  async refresh(item) {
+    await this.tree.refresh(item);
+  }
+
+  async add(item, data) {
+    await this.tree.create(item.parent, data.itemData);
+  }
 
-export class TreeNode {
-  constructor(id, data, domNode, parent) {
-    this.id = id;
-    this.data = data;
-    this.setParent(parent);
-    this.children = [];
-    this.domNode = domNode;
+  async before(item, data) {
+    await this.tree.create(item.parent, data.itemData);
   }
 
-  hasParent() {
-    return this.parentNode !== null && this.parentNode !== undefined;
+  async update(item, data) {
+    await this.tree.update(item, data.itemData);
   }
 
-  parent() {
-    return this.parentNode;
+  async remove(item) {
+    return await this.tree.remove(item);
   }
 
-  setParent(parent) {
-    this.parentNode = parent;
-    this.path = this.id;
-    if (parent !== null && parent !== undefined && parent.path !== undefined) {
-      this.path = parent.path + '.' + this.id;
+  async append(item, data) {
+    return await this.tree.create(item, data);
+  }
+
+  next(item) {
+    if(item) {
+      let parent = this.parent(item);
+      if(parent && parent.children.length > 0) {
+        let idx = parent.children.indexOf(item);
+        if(idx !== -1 && parent.children.length !== idx+1) {
+          return parent.children[idx+1];
+        }
+      }
     }
+    return null;
   }
 
-  getData() {
-    if (this.data === undefined) {
-      return undefined;
-    } else if (this.data === null) {
-      return null;
+  prev(item) {
+    if(item) {
+      let parent = this.parent(item);
+      if(parent && parent.children.length > 0) {
+        let idx = parent.children.indexOf(item);
+        if(idx !== -1 && idx !== 0) {
+          return parent.children[idx-1];
+        }
+      }
     }
-    return Object.assign({}, this.data);
+    return null;
   }
 
-  getHtmlIdentifier() {
-    return this.domNode;
+  async open(item) {
+    if (this.isOpen(item)) { return true; }
+    await this.tree.toggleDirectory(item);
   }
 
-  reload(tree) {
-    return new Promise((resolve)=>{
-      this.unload(tree)
-        .then(()=>{
-          tree.aciTreeApi.setInode(this.domNode);
-          tree.aciTreeApi.deselect(this.domNode);
-          setTimeout(() => {
-            tree.selectNode(this.domNode);
-          }, 0);
-          resolve();
-        });
-    });
-  }
-
-  unload(tree) {
-    return new Promise((resolve, reject)=>{
-      this.children = [];
-      tree.aciTreeApi.unload(this.domNode, {
-        success: ()=>{
-          resolve(true);
-        },
-        fail: ()=>{
-          reject();
-        },
-      });
-    });
+  async ensureVisible(item){
+    await this.tree.ensureVisible(item);
   }
 
-  open(tree, suppressNoDom) {
-    return new Promise((resolve, reject)=>{
-      if(suppressNoDom && (this.domNode == null || typeof(this.domNode) === 'undefined')) {
-        resolve(true);
-      } else if(tree.aciTreeApi.isOpen(this.domNode)) {
-        resolve(true);
-      } else {
-        tree.aciTreeApi.open(this.domNode, {
-          success: ()=>{
-            resolve(true);
-          },
-          fail: ()=>{
-            reject(true);
-          },
-        });
-      }
-    });
+  async openPath(item) {
+    parent = item.parent;
+    await this.tree.openDirectory(parent);
   }
 
-  /*
-   * Find the ancestor with matches this condition
-   */
-  ancestorNode(condition) {
-    let node = this;
+  async close(item) {
+    await this.tree.closeDirectory(item);
+  }
 
-    while (node.hasParent()) {
-      node = node.parent();
-      if (condition(node)) {
-        return node;
-      }
+  async toggle(item) {
+    await this.tree.toggleDirectory(item);
+  }
+
+  async select(item) {
+    await this.tree.setActiveFile(item);
+  }
+
+  async selectNode(item) {
+    this.tree.setActiveFile(item);
+  }
+
+  async unload(item) {
+    await this.tree.unload(item);
+  }
+
+  async addIcon(item, icon) {
+    if (item !== undefined && item.getMetadata('data') !== undefined) {
+      item.getMetadata('data').icon = icon.icon;
     }
+    await this.tree.addIcon(item, icon);
+  }
 
-    return null;
+  removeIcon() {
+    // TBD
   }
 
-  /**
-   * Given a condition returns true if the current node
-   * or any of the parent nodes condition result is true
-   */
-  anyFamilyMember(condition) {
-    if(condition(this)) {
-      return true;
+  setLeaf() {
+    // TBD
+  }
+  async setLabel(item, label) {
+    if(item) {
+      await this.tree.setLabel(item, label);
     }
+  }
 
-    return this.ancestorNode(condition) !== null;
+  async setInode(item) {
+    if(item._children) item._children = null;
+    await this.tree.closeDirectory(item);
   }
-  anyParent(condition) {
-    return this.ancestorNode(condition) !== null;
+
+  deselect(item) {
+    this.tree.deSelectActiveFile(item);
   }
-}
 
-export class Tree {
-  constructor() {
-    this.rootNode = new TreeNode(undefined, {});
-    this.aciTreeApi = undefined;
-    this.draggableTypes = {};
+  wasInit() {
+    // TBD
+    return true;
   }
 
-  /*
-   *
-   * The dropDetailsFunc should return an object of sample
-   * {text: 'xyz', cur: {from:0, to:0} where text is the drop text and
-   * cur is selection range of text after dropping. If returned as
-   * string, by default cursor will be set to the end of text
-   */
-  registerDraggableType(typeOrTypeDict, dropDetailsFunc=null) {
-    if(typeof typeOrTypeDict == 'object') {
-      Object.keys(typeOrTypeDict).forEach((type)=>{
-        this.registerDraggableType(type, typeOrTypeDict[type]);
-      });
-    } else {
-      if(dropDetailsFunc != null) {
-        typeOrTypeDict.replace(/ +/, ' ').split(' ').forEach((type)=>{
-          this.draggableTypes[type] = dropDetailsFunc;
-        });
-      }
+  wasLoad(item) {
+    if (item && item.type === FileType.Directory) {
+      return item.isExpanded;
     }
+    return true;
   }
 
-  getDraggable(type) {
-    if(this.draggableTypes[type]) {
-      return this.draggableTypes[type];
-    } else {
-      return null;
+  parent(item) {
+    return item.parent;
+  }
+
+  first(item) {
+    const model = this.tree.getModel();
+    if (item === undefined || item === null) {
+      return model.root.children[0];
+    }
+
+    if (item.branchSize > 0) {
+      return item.children[0];
     }
+
+    return null;
   }
 
-  prepareDraggable(data, item) {
-    let dropDetailsFunc = this.getDraggable(data._type);
+  children(item) {
+    const model = this.tree.getModel();
+    return item ? (item.children !== null ? item.children : []) : model.root.children;
+  }
 
-    if(dropDetailsFunc != null) {
+  itemFrom(domElem) {
+    return this.tree.getItemFromDOM(domElem[0]);
+  }
 
-      /* addEventListener is used here because import jquery.drag.event
-       * overrides the dragstart event set using element.on('dragstart')
-       * This will avoid conflict.
-       */
-      item.find('.aciTreeItem')
-        .attr('draggable', true)[0]
-        .addEventListener('dragstart', (e)=> {
-          let dropDetails = dropDetailsFunc(data, item);
-
-          if(typeof dropDetails == 'string') {
-            dropDetails = {
-              text:dropDetails,
-              cur:{
-                from:dropDetails.length,
-                to: dropDetails.length,
-              },
-            };
-          } else {
-            if(!dropDetails.cur) {
-              dropDetails = {
-                ...dropDetails,
-                cur:{
-                  from:dropDetails.text.length,
-                  to: dropDetails.text.length,
-                },
-              };
-            }
-          }
-
-          e.dataTransfer.setData('text', JSON.stringify(dropDetails));
-          /* Required by Firefox */
-          if(e.dataTransfer.dropEffect) {
-            e.dataTransfer.dropEffect = 'move';
-          }
-
-          /* setDragImage is not supported in IE. We leave it to
-           * its default look and feel
-           */
-          if(e.dataTransfer.setDragImage) {
-            let dragItem = $(`
-              <div class="drag-tree-node">
-                <span>${_.escape(dropDetails.text)}</span>
-              </div>`
-            );
-
-            $('body .drag-tree-node').remove();
-            $('body').append(dragItem);
-
-            e.dataTransfer.setDragImage(dragItem[0], 0, 0);
-          }
-        });
+  path(item) {
+    if (item) return item.path;
+  }
+
+  pathId(item) {
+    if (item) {
+      let pathIds = item.path.split('/');
+      pathIds.splice(0, 1);
+      return pathIds;
     }
+    return [];
   }
 
-  addNewNode(id, data, domNode, parentPath) {
-    const parent = this.findNode(parentPath);
-    return this.createOrUpdateNode(id, data, parent, domNode);
+  itemFromDOM(domElem) {
+    return this.tree.getItemFromDOM(domElem[0]);
   }
 
-  findNode(path) {
-    if (path === null || path === undefined || path.length === 0) {
-      return this.rootNode;
+  siblings(item) {
+    if (this.hasParent(item)) {
+      let _siblings = this.parent(item).children.filter((_item) => _item.path !== item.path);
+      if (typeof(_siblings) !== 'object') return [_siblings];
+      else _siblings;
+    }
+    return [];
+  }
+
+  hasParent(item) {
+    return item && item.parent ? true : false;
+  }
+
+  isOpen(item) {
+    if (item.type === FileType.Directory) {
+      return item.isExpanded;
+    }
+    return false;
+  }
+
+  isClosed(item) {
+    if (item.type === FileType.Directory) {
+      return !item.isExpanded;
     }
-    return findInTree(this.rootNode, path.join('.'));
+    return false;
+  }
+
+  itemData(item) {
+    return (item !== undefined && item.getMetadata('data') !== undefined) ? item._metadata.data : [];
   }
 
+  getData(item) {
+    return (item !== undefined && item.getMetadata('data') !== undefined) ? item._metadata.data : [];
+  }
+
+  isInode(item) {
+    const children = this.children(item);
+    if (children === null || children === undefined) return false;
+    return children.length > 0 ? true : false;
+  }
+
+  selected() {
+    return this.tree.getActiveFile();
+  }
+
+
   findNodeWithToggle(path) {
     let tree = this;
 
     if(path == null || !Array.isArray(path)) {
       return Promise.reject();
     }
-    path = path.join('.');
+    path = '/browser/' + path.join('/');
 
     let onCorrectPath = function(matchPath) {
       return (matchPath !== undefined && path !== undefined
-        && (path.startsWith(matchPath + '.') || path === matchPath));
+        && (path.startsWith(matchPath) || path === matchPath));
     };
 
     return (function findInNode(currentNode) {
@@ -261,10 +308,11 @@ export class Tree {
         } else if (currentNode.path === path) {
           resolve(currentNode);
         } else {
-          currentNode.open(tree, true)
+          tree.open(currentNode)
             .then(()=>{
-              for (let i = 0, length = currentNode.children.length; i < length; i++) {
-                let childNode = currentNode.children[i];
+              let children = currentNode.children;
+              for (let i = 0, length = children.length; i < length; i++) {
+                let childNode = children[i];
                 if(onCorrectPath(childNode.path)) {
                   resolve(findInNode(childNode));
                   return;
@@ -277,11 +325,11 @@ export class Tree {
             });
         }
       });
-    })(this.rootNode);
+    })(tree.tree.getModel().root);
   }
 
   findNodeByDomElement(domElement) {
-    const path = this.translateTreeNodeIdFromACITree(domElement);
+    const path = domElement.path;
     if(!path || !path[0]) {
       return undefined;
     }
@@ -289,29 +337,23 @@ export class Tree {
     return this.findNode(path);
   }
 
-  selected() {
-    return this.aciTreeApi.selected();
+  addNewNode(id, data, item, parentPath) {
+    let parent;
+    parent = this.findNode(parentPath);
+    return this.createOrUpdateNode(id, data, parent, item);
   }
 
-  /* scrollIntoView will scroll only to top and bottom
-   * Logic can be added for scroll to middle
-   */
-  scrollTo(domElement) {
-    domElement.scrollIntoView();
-  }
-
-  selectNode(aciTreeIdentifier, scrollOnSelect) {
-    this.aciTreeApi.select(aciTreeIdentifier);
-
-    if(scrollOnSelect) {
-      this.scrollTo(aciTreeIdentifier[0]);
+  findNode(path) {
+    if (path === null || path === undefined || path.length === 0) {
+      return this.rootNode;
     }
+    return findInTree(this.rootNode, path);
   }
 
   createOrUpdateNode(id, data, parent, domNode) {
-    let oldNodePath = [id];
-    if(parent !== null && parent !== undefined) {
-      oldNodePath = [parent.path, id];
+    let oldNodePath = id;
+    if(parent !== null && parent !== undefined && parent.path !== undefined && parent.path != '/browser') {
+      oldNodePath = parent.path + '/' + id;
     }
     const oldNode = this.findNode(oldNodePath);
     if (oldNode !== null) {
@@ -330,108 +372,145 @@ export class Tree {
     return node;
   }
 
-  unloadNode(id, data, domNode, parentPath) {
-    let oldNodePath = [id];
-    const parent = this.findNode(parentPath);
-    if(parent !== null && parent !== undefined) {
-      oldNodePath = [parent.path, id];
-    }
-    const oldNode = this.findNode(oldNodePath);
-    if(oldNode) {
-      oldNode.children = [];
+  translateTreeNodeIdFromReactTree(aciTreeNode) {
+    let currentTreeNode = aciTreeNode;
+    let path = [];
+    while (currentTreeNode !== null && currentTreeNode !== undefined) {
+      if (currentTreeNode.path !== '/browser') path.unshift(currentTreeNode.path);
+      if (this.hasParent(currentTreeNode)) {
+        currentTreeNode = this.parent(currentTreeNode);
+      } else {
+        break;
+      }
     }
+    return path;
   }
 
-  /**
-   * Given the JQuery object that contains the ACI Tree
-   * this method is responsible for registering this tree class
-   * to listen to all the events that happen in the ACI Tree.
-   *
-   * At this point in time the only event that we care about is
-   * the addition of a new node.
-   * The function will create a new tree node to store the information
-   * that exist in the ACI for it.
-   */
-  register($treeJQuery) {
-    $treeJQuery.on('acitree', function (event, api, item, eventName) {
-      if (api.isItem(item)) {
-        /* If the id of node is changed, the path should also be changed */
-        if (['added', 'idset', 'beforeunload'].indexOf(eventName) != -1) {
-          const id = api.getId(item);
-          const data = api.itemData(item);
-          const parentId = this.translateTreeNodeIdFromACITree(api.parent(item));
-
-          if(eventName === 'beforeunload') {
-            this.unloadNode(id, data, item, parentId);
-          } else {
-            if(eventName === 'added') {
-              this.prepareDraggable(data, item);
-            }
-
-            this.addNewNode(id, data, item, parentId);
-          }
-          if(data.errmsg) {
-            Alertify.error(data.errmsg);
-          }
+  getTreeNodeHierarchy(identifier) {
+    let idx = 0;
+    let node_cnt = 0;
+    let result = {};
+    if (identifier === undefined) return;
+    let item = TreeNode.prototype.isPrototypeOf(identifier) ? identifier : this.findNode(identifier.path);
+    if (item === undefined) return;
+    do {
+      const currentNodeData = item.getData();
+      if (currentNodeData._type in this.Nodes && this.Nodes[currentNodeData._type].hasId) {
+        const nodeType = mapType(currentNodeData._type, node_cnt);
+        if (result[nodeType] === undefined) {
+          result[nodeType] = _.extend({}, currentNodeData, {
+            'priority': idx,
+          });
+          idx -= 1;
         }
       }
-    }.bind(this));
-    this.aciTreeApi = $treeJQuery.aciTree('api');
+      node_cnt += 1;
+      item = item.hasParent() ? item.parent() : null;
+    } while (item);
 
-    /* Ctrl + Click will trigger context menu. Select the node when Ctrl+Clicked.
-     * When the context menu is visible, the tree should lose focus
-     * to use context menu with keyboard. Otherwise, the tree functions
-     * overrides the keyboard events.
-     */
-    let contextHandler = (ev)=>{
-      let treeItem = this.aciTreeApi.itemFrom(ev.target);
-      if(treeItem.length) {
-        if(ev.ctrlKey) {
-          this.aciTreeApi.select(treeItem);
-        }
-        $(treeItem).on('contextmenu:visible', ()=>{
-          $(treeItem).trigger('blur');
-          $(treeItem).off('contextmenu:visible');
-        });
-      }
-    };
-    $treeJQuery
-      .off('mousedown', contextHandler)
-      .on('mousedown', contextHandler);
+    return result;
   }
 
-  /**
-   * As the name hints this functions works as a layer in between ACI and
-   * the adaptor. Given a ACITree JQuery node find the location of it in the
-   * Tree and then returns and array with the path to the Tree Node in
-   * question
+  /*
    *
-   * This is not optimized and will always go through the full tree
+   * The dropDetailsFunc should return an object of sample
+   * {text: 'xyz', cur: {from:0, to:0} where text is the drop text and
+   * cur is selection range of text after dropping. If returned as
+   * string, by default cursor will be set to the end of text
    */
-  translateTreeNodeIdFromACITree(aciTreeNode) {
-    let currentTreeNode = aciTreeNode;
-    let path = [];
-    while (currentTreeNode !== null && currentTreeNode !== undefined && currentTreeNode.length > 0) {
-      path.unshift(this.aciTreeApi.getId(currentTreeNode));
-      if (this.aciTreeApi.hasParent(currentTreeNode)) {
-        currentTreeNode = this.aciTreeApi.parent(currentTreeNode);
+  registerDraggableType(typeOrTypeDict, dropDetailsFunc=null) {
+    if(typeof typeOrTypeDict == 'object') {
+      Object.keys(typeOrTypeDict).forEach((type)=>{
+        this.registerDraggableType(type, typeOrTypeDict[type]);
+      });
+    } else {
+      if(dropDetailsFunc != null) {
+        typeOrTypeDict.replace(/ +/, ' ').split(' ').forEach((type)=>{
+          this.draggableTypes[type] = dropDetailsFunc;
+        });
+      }
+    }
+  }
+
+  getDraggable(type) {
+    if(this.draggableTypes[type]) {
+      return this.draggableTypes[type];
+    } else {
+      return null;
+    }
+  }
+
+  handleDraggable(e, item) {
+    let data = item.getMetadata('data');
+    let dropDetailsFunc = this.getDraggable(data._type);
+
+    if(dropDetailsFunc != null) {
+
+      /* addEventListener is used here because import jquery.drag.event
+       * overrides the dragstart event set using element.on('dragstart')
+       * This will avoid conflict.
+       */
+      let dropDetails = dropDetailsFunc(data, item);
+
+      if(typeof dropDetails == 'string') {
+        dropDetails = {
+          text:dropDetails,
+          cur:{
+            from:dropDetails.length,
+            to: dropDetails.length,
+          },
+        };
       } else {
-        break;
+        if(!dropDetails.cur) {
+          dropDetails = {
+            ...dropDetails,
+            cur:{
+              from:dropDetails.text.length,
+              to: dropDetails.text.length,
+            },
+          };
+        }
+      }
+
+      e.dataTransfer.setData('text', JSON.stringify(dropDetails));
+      /* Required by Firefox */
+      if(e.dataTransfer.dropEffect) {
+        e.dataTransfer.dropEffect = 'move';
+      }
+
+      /* setDragImage is not supported in IE. We leave it to
+         * its default look and feel
+         */
+      if(e.dataTransfer.setDragImage) {
+        let dragItem = $(`
+            <div class="drag-tree-node">
+              <span>${_.escape(dropDetails.text)}</span>
+            </div>`
+        );
+
+        $('body .drag-tree-node').remove();
+        $('body').append(dragItem);
+
+        e.dataTransfer.setDragImage(dragItem[0], 0, 0);
       }
     }
-    return path;
   }
 }
 
+function mapType(type, idx) {
+  return (type === 'partition' && idx > 0) ? 'table' : type;
+}
+
+
+
 /**
  * Given an initial node and a path, it will navigate through
  * the new tree to find the node that matches the path
  */
-function findInTree(rootNode, path) {
+export function findInTree(rootNode, path) {
   if (path === null) {
     return rootNode;
   }
-
   return (function findInNode(currentNode) {
 
     /* No point in checking the children if
diff --git a/web/pgadmin/static/js/tree/tree_init.tsx b/web/pgadmin/static/js/tree/tree_init.tsx
new file mode 100644
index 000000000..4d67ecf21
--- /dev/null
+++ b/web/pgadmin/static/js/tree/tree_init.tsx
@@ -0,0 +1,87 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2021, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import * as React from 'react';
+import { render } from 'react-dom';
+import { FileTreeX, TreeModelX } from 'pgadmin4-tree';
+import {Tree} from './tree';
+
+import { IBasicFileSystemHost } from 'react-aspen';
+import { ManageTreeNodes } from './tree_nodes'
+
+var initBrowserTree = async (pgBrowser) => {
+  const MOUNT_POINT = '/browser'
+
+  // Setup host
+  let mtree = new ManageTreeNodes();
+
+  // Init Tree with the Tree Parent node '/browser'
+  mtree.init(MOUNT_POINT);
+
+  const host: IBasicFileSystemHost = {
+    pathStyle: 'unix',
+    getItems: async (path) => {
+      let nodes = await mtree.readNode(path);
+      return nodes;
+    },
+  }
+
+  // Create Node
+  const create = async (parentPath, _data): Promise<IFileEntryItem> => {
+    try {
+      let _node_path = parentPath + "/" + _data.id
+      return mtree.addNode(parentPath, _node_path, _data)
+    } catch (error) {
+      return null // or throw error as you see fit
+    }
+  }
+
+
+  // Remove Node
+  const remove = async (path: string, _removeOnlyChild): Promise<boolean> => {
+    try {
+      await mtree.removeNode(path, _removeOnlyChild);
+      return true
+    } catch (error) {
+      return false // or throw error as you see fit
+    }
+  }
+
+  // Update Node
+  const update = async (path: string, data): Promise<boolean> => {
+    try {
+      await mtree.updateNode(path, data);
+      return true
+    } catch (error) {
+      return false // or throw error as you see fit
+    }
+  }
+
+  const treeModelX = new TreeModelX(host, MOUNT_POINT)
+
+  const itemHandle = function onReady(handler) {
+    // Initialize pgBrowser Tree
+    pgBrowser.tree = new Tree(handler, mtree, pgBrowser);
+    return true;
+  }
+
+  await treeModelX.root.ensureLoaded()
+
+  // Render Browser Tree
+  await render(
+    <div>
+      <FileTreeX height={999} width={'100%'} model={treeModelX}
+        onReady={itemHandle} create={create} remove={remove} update={update}/>
+     </div>, document.getElementById('tree'));
+}
+
+module.exports = {
+  initBrowserTree: initBrowserTree,
+};
+
